diff --git a/books/bookvol10.4.pamphlet b/books/bookvol10.4.pamphlet
index 7954153..c38e30a 100644
--- a/books/bookvol10.4.pamphlet
+++ b/books/bookvol10.4.pamphlet
@@ -136610,14 +136610,14 @@ SmithNormalForm(R,Row,Col,M) : Exports == Implementation where
              -- elementary operation of second kind: add to row i--
                          -- a*row j  (i^=j) --
     elRow2(m : M,a:R,i:I,j:I) : M ==
-      vec:= map(a*#1,row(m,j))
+      vec:= map(x +-> a*x,row(m,j))
       vec:=map("+",row(m,i),vec)
       setRow!(m,i,vec)
       m
              -- elementary operation of second kind: add to column i --
                            -- a*column j (i^=j) --
     elColumn2(m : M,a:R,i:I,j:I) : M ==
-      vec:= map(a*#1,column(m,j))
+      vec:= map(x +-> a*x,column(m,j))
       vec:=map("+",column(m,i),vec)
       setColumn!(m,i,vec)
       m
@@ -136646,7 +136646,7 @@ SmithNormalForm(R,Row,Col,M) : Exports == Implementation where
       -- add to column j -mjj*column i --
       rMat:=elColumn2(rMat,-mjj,j,i)
       -- multiply by -1 column j --
-      setColumn!(rMat,j,map(-1 * #1,column(rMat,j)))
+      setColumn!(rMat,j,map(x +-> -1*x,column(rMat,j)))
       [m,lMat,rMat]
                
 
@@ -136687,7 +136687,7 @@ SmithNormalForm(R,Row,Col,M) : Exports == Implementation where
           while zero?(tjj:=t1(j,j0)) repeat j0:=j0+1
           u(i,j) :=((mm(i,j0) - ("+"/[u(i,k) * t1(k,j0) for k in 1..(j-1)])) exquo
                     tjj) :: R
-      u1:M2:= map(#1 :: QF,u)$MATCAT1
+      u1:M2:= map(x +-> x::QF,u)$MATCAT1
       [t,map(retract$QF,(inverse u1)::M2)$MATCAT2]
 
                 --- Hermite normal form of m ---
diff --git a/changelog b/changelog
index 6976eba..c18e866 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20090621 tpd src/axiom-website/patches.html 20090621.01.tpd.patch
+20090621 tpd books/bookvol10.4 SMITH +-> conversion
 20090620 tpd src/axiom-website/patches.html 20090620.09.tpd.patch
 20090620 tpd Makefile build input.dvi in parallel with src
 20090620 tpd src/axiom-website/patches.html 20090620.08.tpd.patch
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 148d1ef..f81ad24 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -1617,5 +1617,7 @@ bookvol10.4 INTPAF +-> conversion<br/>
 bookvol10.4 RETSOL +-> conversion<br/>
 <a href="patches/20090620.09.tpd.patch">20090620.09.tpd.patch</a>
 Makefile build input.dvi in parallel with src<br/>
+<a href="patches/20090621.01.tpd.patch">20090621.01.tpd.patch</a>
+bookvol10.4 SMITH +-> conversion<br/>
  </body>
 </html>
